// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import jakarta.el.MethodExpression;
import jakarta.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUISheet;
import org.apache.myfaces.tobago.layout.ShowPosition;
import org.apache.myfaces.tobago.model.Selectable;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import jakarta.annotation.Generated;
import jakarta.el.ELException;
import jakarta.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import jakarta.el.MethodExpression;
import jakarta.el.ValueExpression;

/**
 Render a sheet element.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.SheetTagDeclaration}.
 */
@Generated("component.stg")
public class UISheet
    extends AbstractUISheet  {

  private static final Tags TAG = Tags.sheet;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "jakarta.faces.Data";

  private static final Collection<String> EVENT_NAMES = Arrays.asList("reload");

  @Override
  public Collection<String> getEventNames() {
    return EVENT_NAMES;
  }

  @Override
  public String getDefaultEventName() {
    return "reload";
  }


  enum PropertyKeys {
    markup,
    showPageRange,
    showPagingAlways,
    directLinkCount,
    showRootJunction,
    columns,
    showHeader,
    lazy,
    showPageRangeArrows,
    selectable,
    sortActionListener,
    showDirectLinks,
    showDirectLinksArrows,
    showRoot,
    showRowRange,
    maxSortColumns,
    customClass,
    stateChangeListener,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Flag indicating whether and where the range pages should
   rendered in the sheet's footer. Rendering this range also offers the
   capability to enter the index displayed page directly.
  <br>Default: <code>right</code><br>Allowed Values: <code>left,center,right,none</code>
  */
  public org.apache.myfaces.tobago.layout.ShowPosition getShowPageRange() {
    org.apache.myfaces.tobago.layout.ShowPosition showPageRange = (org.apache.myfaces.tobago.layout.ShowPosition) getStateHelper().eval(PropertyKeys.showPageRange);
    if (showPageRange != null) {
      return showPageRange;
    }
    return org.apache.myfaces.tobago.layout.ShowPosition.right;
  }

  public void setShowPageRange(org.apache.myfaces.tobago.layout.ShowPosition showPageRange) {
    getStateHelper().put(PropertyKeys.showPageRange, showPageRange);
  }

  /**
  Flag indicating whether or not the paging panel should be display, if it is not needed for paging.<br>
   <ul>
   <li>showPagingAlways="false" which is the default means, that the paging footer should be displayed,
   only when it is needed.
   <ul>
   <li>When the rows="0" paging is not needed, so the footer will not be rendered,
   <li>when rows="N", N &gt; 0 and the size of the data value is &lt;= N paging is not needed
   and the footer will not be rendered,
   <li>in any other case the paging footer will be displayed.
   </ul>
   <li>showPagingAlways="true" means, that the paging footer should be displayed in any case.
   </ul>
  <br>Default: <code>false</code>
  */
  public boolean isShowPagingAlways() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showPagingAlways);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowPagingAlways(boolean showPagingAlways) {
    getStateHelper().put(PropertyKeys.showPagingAlways, showPagingAlways);
  }

  /**
  The count of rendered direct paging links in the sheet's footer.<br>
  <br>Default: <code>9</code>
  */
  public java.lang.Integer getDirectLinkCount() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.directLinkCount);
    if (value != null) {
      return value.intValue();
    }
    return 9;
  }

  public void setDirectLinkCount(java.lang.Integer directLinkCount) {
    getStateHelper().put(PropertyKeys.directLinkCount, directLinkCount);
  }

  /**
  Only applicable in the case that the data model is a tree.
   This flag indicates that the root node should be displayed with an open-close-switch.
  <br>Default: <code>false</code>
  */
  public boolean isShowRootJunction() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showRootJunction);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowRootJunction(boolean showRootJunction) {
    getStateHelper().put(PropertyKeys.showRootJunction, showRootJunction);
  }

  /**
  <p>
   LayoutConstraints for column layout.
   Contains a space separated list of layout tokens '&lt;n&gt;fr', '&lt;x&gt;px', '&lt;x&gt;%' or 'auto',
   where x is a number and n is an integer.
   </p>

  */
  public java.lang.String getColumns() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.columns);
  }

  public void setColumns(java.lang.String columns) {
    getStateHelper().put(PropertyKeys.columns, columns);
  }

  /**
  Flag indicating the header should be rendered.
  <br>Default: <code>true</code>
  */
  public boolean isShowHeader() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showHeader);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setShowHeader(boolean showHeader) {
    getStateHelper().put(PropertyKeys.showHeader, showHeader);
  }

  /**
  Lazy loading by scroll event.
  <br>Default: <code>false</code>
  */
  public boolean isLazy() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.lazy);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setLazy(boolean lazy) {
    getStateHelper().put(PropertyKeys.lazy, lazy);
  }

  /**
  Flag indicating if paging arrows are shown near page range
  <br>Default: <code>true</code>
  */
  public boolean isShowPageRangeArrows() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showPageRangeArrows);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setShowPageRangeArrows(boolean showPageRangeArrows) {
    getStateHelper().put(PropertyKeys.showPageRangeArrows, showPageRangeArrows);
  }

  /**
  Indicating the selection mode of the sheet.
  <br>Default: <code>multi</code><br>Allowed Values: <code>none,single,singleOrNone,multi</code>
  */
  public org.apache.myfaces.tobago.model.Selectable getSelectable() {
    org.apache.myfaces.tobago.model.Selectable selectable = (org.apache.myfaces.tobago.model.Selectable) getStateHelper().eval(PropertyKeys.selectable);
    if (selectable != null) {
      return selectable;
    }
    return org.apache.myfaces.tobago.model.Selectable.multi;
  }

  public void setSelectable(org.apache.myfaces.tobago.model.Selectable selectable) {
    getStateHelper().put(PropertyKeys.selectable, selectable);
  }

  public jakarta.el.MethodExpression getSortActionListenerExpression() {
    return (jakarta.el.MethodExpression) getStateHelper().eval(PropertyKeys.sortActionListener);
  }

  public void setSortActionListenerExpression(jakarta.el.MethodExpression sortActionListener) {
    getStateHelper().put(PropertyKeys.sortActionListener, sortActionListener);
  }


  /**
  Flag indicating whether or not a range of direct paging links should be
   rendered in the sheet's footer.
  <br>Default: <code>center</code><br>Allowed Values: <code>left,center,right,none</code>
  */
  public org.apache.myfaces.tobago.layout.ShowPosition getShowDirectLinks() {
    org.apache.myfaces.tobago.layout.ShowPosition showDirectLinks = (org.apache.myfaces.tobago.layout.ShowPosition) getStateHelper().eval(PropertyKeys.showDirectLinks);
    if (showDirectLinks != null) {
      return showDirectLinks;
    }
    return org.apache.myfaces.tobago.layout.ShowPosition.center;
  }

  public void setShowDirectLinks(org.apache.myfaces.tobago.layout.ShowPosition showDirectLinks) {
    getStateHelper().put(PropertyKeys.showDirectLinks, showDirectLinks);
  }

  /**
  Flag indicating if paging arrows are shown near direct links
  <br>Default: <code>false</code>
  */
  public boolean isShowDirectLinksArrows() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showDirectLinksArrows);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowDirectLinksArrows(boolean showDirectLinksArrows) {
    getStateHelper().put(PropertyKeys.showDirectLinksArrows, showDirectLinksArrows);
  }

  /**
  Only applicable in the case that the data model is a tree.
   This flag indicates that the root node should be displayed.
   Often in tree structures the root node is special and should not be displayed.
  <br>Default: <code>false</code>
  */
  public boolean isShowRoot() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showRoot);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowRoot(boolean showRoot) {
    getStateHelper().put(PropertyKeys.showRoot, showRoot);
  }

  /**
  Flag indicating whether or not the range of displayed rows should
   rendered in the sheet's footer. Rendering this range also offers the
   capability to enter the index of the start row directly.
  <br>Default: <code>left</code><br>Allowed Values: <code>left,center,right,none</code>
  */
  public org.apache.myfaces.tobago.layout.ShowPosition getShowRowRange() {
    org.apache.myfaces.tobago.layout.ShowPosition showRowRange = (org.apache.myfaces.tobago.layout.ShowPosition) getStateHelper().eval(PropertyKeys.showRowRange);
    if (showRowRange != null) {
      return showRowRange;
    }
    return org.apache.myfaces.tobago.layout.ShowPosition.left;
  }

  public void setShowRowRange(org.apache.myfaces.tobago.layout.ShowPosition showRowRange) {
    getStateHelper().put(PropertyKeys.showRowRange, showRowRange);
  }

  /**
  The maximum count of multi-sorted columns to indicate.
  <br>Default: <code>0</code>
  */
  public java.lang.Integer getMaxSortColumns() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.maxSortColumns);
    if (value != null) {
      return value.intValue();
    }
    return 0;
  }

  public void setMaxSortColumns(java.lang.Integer maxSortColumns) {
    getStateHelper().put(PropertyKeys.maxSortColumns, maxSortColumns);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  public jakarta.el.MethodExpression getStateChangeListenerExpression() {
    return (jakarta.el.MethodExpression) getStateHelper().eval(PropertyKeys.stateChangeListener);
  }

  public void setStateChangeListenerExpression(jakarta.el.MethodExpression stateChangeListener) {
    getStateHelper().put(PropertyKeys.stateChangeListener, stateChangeListener);
  }



  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}